#include <EEPROM.h>

void readFirstStart() {
 EEPROM.begin(4095);
 String tmpValue = ""; 
 for (int i = 0; i < 1; ++i){tmpValue += char(EEPROM.read(550 + i));}
 first_Startup = tmpValue.toInt();
 EEPROM.end();
 delay(100); 
 //Serial.println("FIRST_STARTUP : " + String(first_Startup));
 delay(100);
}

void readEEPROM(){

 EEPROM.begin(1024);
 String tmpValue = ""; 

  
 // Read the ioBroker Values
 tmpValue = "";
 for (int i = 0; i < 16; ++i){tmpValue += char(EEPROM.read(100 + i));}
 tmpValue.toCharArray(host_ioBrokerIP, 16);
 tmpValue = "";
 for (int i = 0; i < 5; ++i){tmpValue += char(EEPROM.read(120 + i));}
 host_ioBrokerPORT = tmpValue.toInt();
 tmpValue = "";
 for (int i = 0; i < 1; ++i){tmpValue += char(EEPROM.read(128 + i));}
 if (IOB_active < 0 || IOB_active > 1){IOB_active = 0;}
 IOB_active = tmpValue.toInt();
 tmpValue = "";
 for (int i = 0; i < 80; ++i){tmpValue += char(EEPROM.read(150 + i));}
 tmpValue.toCharArray(IOB_Datapoint_Path, 80);
 tmpValue = "";
 for (int i = 0; i < 80; ++i){tmpValue += char(EEPROM.read(250 + i));}
 tmpValue.toCharArray(IOB_Datapoint_Sub, 80);
 tmpValue = "";
 for (int i = 0; i < 80; ++i){tmpValue += char(EEPROM.read(350 + i));}
 tmpValue.toCharArray(IOB_Datapoint_State, 80);
 tmpValue = "";
 for (int i = 0; i < 80; ++i){tmpValue += char(EEPROM.read(450 + i));}
 tmpValue.toCharArray(IOB_Datapoint_Message, 80);
 tmpValue = "";
 for (int i = 0; i < 8; ++i){tmpValue += char(EEPROM.read(130 + i));}
 if (dSendState < 60000) {dSendState = 60000;}
 dSendState = tmpValue.toInt();

 // Read the CCU CuxD Values
 
 tmpValue = "";
 for (int i = 0; i < 38; ++i){tmpValue += char(EEPROM.read(600 + i));}
 tmpValue.toCharArray(CCU_CuxDAdress, 38);
 tmpValue = "";
 for (int i = 0; i < 2; ++i){tmpValue += char(EEPROM.read(555 + i));}
 CCU_CuxD = tmpValue.toInt();
 if (CCU_CuxD < 0 || CCU_CuxD > 1){CCU_CuxD = 0;} 
 tmpValue = "";
 for (int i = 0; i < 16; ++i){tmpValue += char(EEPROM.read(560 + i));}
 tmpValue.toCharArray(host_CCUIP, 16);




 //read the general Command States
 tmpValue = "";
 for (int i = 0; i < 2; ++i){tmpValue += char(EEPROM.read(97 + i));}
 stateONPowerON = tmpValue.toInt();
 if (stateONPowerON < 0 || stateONPowerON > 1){stateONPowerON = 0;} 
 tmpValue = "";
 for (int i = 0; i < 2; ++i){tmpValue += char(EEPROM.read(140 + i));}
 enableReconnect = tmpValue.toInt();
 if (enableReconnect < 0 || enableReconnect > 1){enableReconnect = 1;} 
 
 
 EEPROM.end();
 /*  

 Serial.println("ioBroker IP EEPROM : " + String(host_ioBrokerIP));
 delay(100);
 Serial.println("ioBroker PORT EEPROM : " + String(host_ioBrokerPORT));
 delay(100);
 Serial.println("ioBroker PATH EEPROM : " + String(IOB_Datapoint_Path));
 delay(100);
 Serial.println("ioBroker SUBPATH EEPROM : " + String(IOB_Datapoint_Sub));
 delay(100);
 Serial.println("ioBroker STATE NAME EEPROM : " + String(IOB_Datapoint_State));
 delay(100);
 Serial.println("ioBroker STATE TIME EEPROM : " + String(IOB_SendState));
 delay(100);
 Serial.println("Reconnect enabled EEPROM : " + String(enableReconnect));
 delay(100);
*/
}


void writeEEPROM(){
//  eeprom_Function is needed to write to the correct address in EEPROM

/*
 * ##### USED EEPROM ADRESSES #####
 * 0  - 32    : SSID 
 * 33 - 95    : SSID Password
 * 97 - 98    : Relay State on PowerON /7

 * 100 - 116  : ioBroker IP /1 
 * 120 - 125  : ioBroker PORT /2
 * 128 - 129  : ioBroker active /13
 * 130 - 138  : ioBroker SendState /8
 * 140 - 141  : Wifi.reconnect enabled /9 
 * 150 - 230  : ioBroker Datapoint /3
 * 250 - 330  : ioBroker Datapoint Subpath /4
 * 350 - 430  : ioBroker Datapoint State Name /5
 * 450 - 530  : ioBroker Datapoint Message Name /6
 * 550 - 551  : First Startup /99
 * 555 - 556  : CCU CUxD Enabled /10
 * 560 - 598  : host_CCUIP Adress /12
 * 600 - 637  : CCU CUxD Adress /11

 */
  EEPROM.begin(1024);
  String tmpValue = "";
  
  switch (eeprom_Function) {

    case 1: //IOB IP
      tmpValue = String(host_ioBrokerIP);
      for (int i = 0; i < 16; ++i){EEPROM.write(100 + i, tmpValue[i]);}
      //Serial.println("ioBroker IP written to EEPROM");
      break;
    case 2: //IOB PORT
      tmpValue = String(host_ioBrokerPORT);
      for (int i = 0; i < 5; ++i){EEPROM.write(120 + i, tmpValue[i]);}
      //Serial.println("ioBroker PORT written to EEPROM");
      break;
    case 3: //IOB Path
      tmpValue = String(IOB_Datapoint_Path);
      for (int i = 0; i < 80; ++i){EEPROM.write(150 + i, tmpValue[i]);}
      //Serial.println("ioBroker Datapoint Name written to EEPROM");
      break;
    case 4: //IOB SUB
      tmpValue = String(IOB_Datapoint_Sub);
      for (int i = 0; i < 80; ++i){EEPROM.write(250 + i, tmpValue[i]);}
      //Serial.println("ioBroker Datapoint Path written to EEPROM");
      break;
    case 5: //IOB State
      tmpValue = String(IOB_Datapoint_State);
      for (int i = 0; i < 80; ++i){EEPROM.write(350 + i, tmpValue[i]);}
      //Serial.println("ioBroker State Name written to EEPROM");
      break;
    case 6: //IOB Message
      tmpValue = String(IOB_Datapoint_Message);
      for (int i = 0; i < 80; ++i){EEPROM.write(450 + i, tmpValue[i]);}
      //Serial.println("ioBroker Message Name written to EEPROM");
      break;
    case 7: //Relay PowerON State
      tmpValue = String(stateONPowerON);
      for (int i = 0; i < 2; ++i){EEPROM.write(97 + i, tmpValue[i]);}
      //Serial.println("PowerOn State written to EEPROM");
      break;
     case 8: //IOB_StateMessage_Time
      tmpValue = String(dSendState);
      if (dSendState < 60000) {dSendState = 60000;}
      for (int i = 0; i < 8; ++i){EEPROM.write(130 + i, tmpValue[i]);}
      //Serial.println("State Message Time written to EEPROM");
      break;
     case 9: //enable Wifi.reconnect
      tmpValue = String(enableReconnect);
      for (int i = 0; i < 2; ++i){EEPROM.write(140 + i, tmpValue[i]);}
      //Serial.println("Wifi.Reconncet enabled is written to EEPROM");
      break;
    case 10: //CuxD_enabled
      tmpValue = String(CCU_CuxD);
      for (int i = 0; i < 1; ++i){EEPROM.write(555 + i, tmpValue[i]);}
      //Serial.println("CuxD Enabled written to EEPROM");  
      break;
    case 11: //CuxD Adress
      tmpValue = String(CCU_CuxDAdress);
      for (int i = 0; i < 38; ++i){EEPROM.write(600 + i, tmpValue[i]);}
      //Serial.println("CCU CuxD Adress written to EEPROM");
      break;
    case 12: //CCU IP Adress
      tmpValue = String(host_CCUIP);
      for (int i = 0; i < 16; ++i){EEPROM.write(560 + i, tmpValue[i]);}
      //Serial.println("CCU IP Adress written to EEPROM");
      break;
    case 13: //IOB active
      tmpValue = String(IOB_active);
      for (int i = 0; i < 1; ++i){EEPROM.write(128 + i, tmpValue[i]);}
      //Serial.println("ioBroker active  written to EEPROM");
      break;


      
    case 99: //First_Startup
      tmpValue = String(first_Startup);
      for (int i = 0; i < 1; ++i){EEPROM.write(550 + i, tmpValue[i]);}
      //Serial.println("STARTUP written to EEPROM");  
      break;
      
      
      default:
      break;
  }
  EEPROM.commit();
  delay(1000); 
  EEPROM.end();
}
